<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
               "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
lang="en" xml:lang="en">
<head>
<title>DMV/CCM &ndash; todo-list / progress</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
<meta name="generator" content="Org-mode"/>
<meta name="generated" content="2008-09-21 19:00:58 CEST"/>
<meta name="author" content="Kevin Brubeck Unhammer"/>
<style type="text/css">
  html { font-family: Times, serif; font-size: 12pt; }
  .title  { text-align: center; }
  .todo   { color: red; }
  .done   { color: green; }
  .tag    { background-color:lightblue; font-weight:normal }
  .target { }
  .timestamp { color: grey }
  .timestamp-kwd { color: CadetBlue }
  p.verse { margin-left: 3% }
  pre {
	border: 1pt solid #AEBDCC;
	background-color: #F3F5F7;
	padding: 5pt;
	font-family: courier, monospace;
        font-size: 90%;
        overflow:auto;
  }
  table { border-collapse: collapse; }
  td, th { vertical-align: top; }
  dt { font-weight: bold; }
</style><link rel="stylesheet" type="text/css" href="http://www.student.uib.no/~kun041/org.css">
<!-- override with local style.css: -->
<link rel="stylesheet" type="text/css" href="./style.css">
</head><body>
<h1 class="title">DMV/CCM &ndash; todo-list / progress</h1>
<div id="table-of-contents">
<h2>Table of Contents</h2>
<div id="text-table-of-contents">
<ul>
<li><a href="#sec-1">1 DMV/CCM report and project</a></li>
<li><a href="#sec-2">2 Notation</a></li>
<li><a href="#sec-3">3 Testing the dependency parsed WSJ</a>
<ul>
<li><a href="#sec-3.1">3.1 [#A] Should <code>def evaluate</code> use add_root?</a></li>
</ul>
</li>
<li><a href="#sec-4">4 Combine CCM with DMV</a></li>
<li><a href="#sec-5">5 Reestimate P_ORDER ?</a></li>
<li><a href="#sec-6">6 Most Probable Parse</a>
<ul>
<li><a href="#sec-6.1">6.1 Find MPP with CCM</a></li>
<li><a href="#sec-6.2">6.2 Find Most Probable Parse of given test sentence, in DMV</a></li>
</ul>
</li>
<li><a href="#sec-7">7 Initialization   </a>
<ul>
<li><a href="#sec-7.1">7.1 CCM Initialization    </a></li>
</ul>
</li>
<li><a href="#sec-8">8 [#C] Alternative CNF for DMV</a>
<ul>
<li><a href="#sec-8.1">8.1 [#A] Make and implement an equivalent grammar that's <i>pure</i> CNF</a></li>
<li><a href="#sec-8.2">8.2 [#A] convert L&amp;Y-based reestimation into P_ATTACH and P_STOP values</a></li>
<li><a href="#sec-8.3">8.3 [#C] move as much as possible into common_dmv.py</a></li>
<li><a href="#sec-8.4">8.4 L&amp;Y-based reestimation for cnf_dmv</a></li>
<li><a href="#sec-8.5">8.5 dmv2cnf re-estimation formulas</a></li>
<li><a href="#sec-8.6">8.6 inner and outer for cnf_dmv.py, also cnf_harmonic.py </a></li>
</ul>
</li>
<li><a href="#sec-9">9 [#C] Deferred</a>
<ul>
<li><a href="#sec-9.1">9.1 Clean up reestimation code</a></li>
<li><a href="#sec-9.2">9.2 [#A] compare speed of w_left/right(&hellip;) and w(LEFT/RIGHT, &hellip;)</a></li>
<li><a href="#sec-9.3">9.3 when reestimating P_STOP etc, remove rules with p &lt; epsilon</a></li>
<li><a href="#sec-9.4">9.4 inner_dmv, short ranges and impossible attachment</a></li>
<li><a href="#sec-9.5">9.5 clean up the module files</a></li>
<li><a href="#sec-9.6">9.6 Some (tagged) sentences are bound to come twice</a></li>
<li><a href="#sec-9.7">9.7 tags as numbers or tags as strings?</a></li>
</ul>
</li>
<li><a href="#sec-10">10 Adjacency and combining it with the inside-outside algorithm</a>
<ul>
<li><a href="#sec-10.1">10.1 Possible alternate type of adjacency</a></li>
</ul>
</li>
<li><a href="#sec-11">11 Python-stuff</a></li>
<li><a href="#sec-12">12 Git</a></li>
</ul>
</div>
</div>

<div id="outline-container-1" class="outline-2">
<h2 id="sec-1">1 DMV/CCM report and project</h2>
<div id="text-1">

<p><span class="timestamp-kwd">DEADLINE: </span> <span class="timestamp">2008-09-21 Sun</span><br/>
</p><ul>
<li>
<a href="http://www.student.uib.no/~kun041/dmvccm/report.pdf">report.pdf</a> &ndash; Draft report for the whole project, including formulas
for the full algorithms

</li>
<li>
<a href="src/main.py">main.py</a> &ndash; evaluation, corpus likelihoods
</li>
<li>
<a href="src/wsjdep.py">wsjdep.py</a> &ndash; corpus reader for the dependency parsed WSJ

</li>
<li>
<a href="src/loc_h_dmv.py">loc_h_dmv.py</a> &ndash; DMV-IO and reestimation
</li>
<li>
<a href="src/loc_h_harmonic.py">loc_h_harmonic.py</a> &ndash; DMV initialization

</li>
<li>
<a href="src/common_dmv.py">common_dmv.py</a> &ndash; various functions used by loc_h_dmv and others
</li>
<li>
<a href="src/io.py">io.py</a> &ndash; non-DMV IO

</li>
</ul>

<p>Deprecated:
</p><ul>
<li>
<a href="src/cnf_dmv.py">cnf_dmv.py</a> &ndash; cnf-like implementation of DMV
</li>
<li>
<a href="src/cnf_harmonic.py">cnf_harmonic.py</a> &ndash; initialization for cnf_dmv

</li>
</ul>

<p><a href="http://www.student.uib.no/~kun041/dmvccm/DMVCCM_archive.html">Archived entries</a> from this file.
</p></div>

</div>

<div id="outline-container-2" class="outline-2">
<h2 id="sec-2">2 Notation</h2>
<div id="text-2">

<p><pre class="example">
 old notes:   new notes:   in tex/code (constants):    in Klein thesis:
--------------------------------------------------------------------------------------
 _h_            _h_            SEAL                    bar over h
  h_             h&gt;&lt;           RGOL                    right-under-left-arrow over h
  h              h&gt;            GOR                     right-arrow over h

               &gt;&lt;h             LGOR                    left-under-right-arrow over h
                &lt;h             GOL                     left-arrow over h
</pre>
These are represented in the code as pairs <code>(s_h,h)</code>, where <code>h</code> is an
integer (POS-tag) and <code>s_h</code> &isin; <code>{SEAL,RGOL,GOR,LGOR,GOL}</code>.
</p>
<p>
<code>P_ATTACH</code> and <code>P_CHOOSE</code> are synonymous, I try to use the
former. Also, 
<pre class="example">
 P_GO_AT(a|h,dir,adj) := P_ATTACH(a|h,dir)*(1-P_STOP(STOP|h,dir,adj)
</pre>
</p>
<p>
(precalculated after each reestimation with <code>g.p_GO_AT = make_GO_AT(g.p_STOP,g.p_ATTACH)</code>)
</p>
</div>

</div>

<div id="outline-container-3" class="outline-2">
<h2 id="sec-3">3 Testing the dependency parsed WSJ</h2>
<div id="text-3">

<p><a href="src/wsjdep.py">wsjdep.py</a> uses NLTK (sort of) to get a dependency parsed version of
WSJ10 into the format used in mpp() in loc_h_dmv.py.
</p>
<p>
As a default, <code>WSJDepCorpusReader</code> looks for the file <code>wsj.combined.10.dep</code> in
<code>../corpus/wsjdep</code>.
</p>
<p>
Only <code>sents()</code>, <code>tagged_sents()</code> and <code>parsed_sents()</code> (plus a new function
<code>tagonly_sents()</code>) are implemented, the other NLTK corpus functions are
..um.. undefined&hellip;
</p>
</div>

<div id="outline-container-3.1" class="outline-3">
<h3 id="sec-3.1">3.1 <span class="todo">TODO</span> [#A] Should <code>def evaluate</code> use add_root?</h3>
<div id="text-3.1">

<p><a href="src/main.py">main.py</a> evaluate
<a href="src/wsjdep.py">wsjdep.py</a> add_root
</p>
<p>
(just has to count how many pairs are in there; Precision and Recall)
</p></div>
</div>

</div>

<div id="outline-container-4" class="outline-2">
<h2 id="sec-4">4 <span class="todo">TOGROK</span> Combine CCM with DMV</h2>
<div id="text-4">


<p>
<a name="comboquestions">&nbsp;</a>
</p>
<p>
Questions about the <code>P_COMBO</code> info in <a href="http://www.eecs.berkeley.edu/~klein/papers/klein_thesis.pdf">Klein's thesis</a>:
</p><ul>
<li>
Page 109 (pdf: 125): We have to premultiply "all our probabilities"
by the CCM base product <i>&Pi;<sub>&lt;i,j&gt;</sub>   P<sub>SPAN</sub>(&alpha;(i,j,s)|false)P<sub>CONTEXT</sub>(&beta;(i,j,s)|false)</i>; which
probabilities are included under "all"? I'm assuming this includes
<code>P_ATTACH</code> since each time <code>P_ATTACH</code> is used, <i>&phi;</i> is multiplied in
(pp.110-111 ibid.); but <i>&phi;</i> is not used for STOPs, so should we not
have our CCM product multiplied in there? How about <code>P_ROOT</code>?
(Guessing <code>P_ORDER</code> is way out of the question&hellip;)
</li>
<li>
For the outside probabilities, is it correct to assume we multiply
in <i>&phi;(j,k)</i> or <i>&phi;(k,i)</i> when calculating <code>inner(i,j...)</code>? (Eg., only
for the outside part, not for the whole range.) I don't understand
the notation in <code>O()</code> on p.103.
</li>
</ul>
</div>

</div>

<div id="outline-container-5" class="outline-2">
<h2 id="sec-5">5 <span class="todo">TOGROK</span> Reestimate P_ORDER ?</h2>
<div id="text-5">

</div>

</div>

<div id="outline-container-6" class="outline-2">
<h2 id="sec-6">6 Most Probable Parse</h2>
<div id="text-6">


</div>

<div id="outline-container-6.1" class="outline-3">
<h3 id="sec-6.1">6.1 <span class="todo">TOGROK</span> Find MPP with CCM</h3>
<div id="text-6.1">

</div>

</div>

<div id="outline-container-6.2" class="outline-3">
<h3 id="sec-6.2">6.2 <span class="done">DONE</span> Find Most Probable Parse of given test sentence, in DMV</h3>
<div id="text-6.2">

<p><span class="timestamp-kwd">CLOSED: </span> <span class="timestamp">2008-07-23 Wed 10:56</span><br/>
inner() optionally keeps track of the highest probability children of
any node in <code>mpptree</code>. Say we're looking for <code>inner(i,j,(s_h,h),loc_h)</code> in
a certain sentence, and we find some possible left and right children,
we add to <code>mpptree[i,j,(s_h,h),loc_h]</code> the triple <code>(p, L, R)</code> where <code>L</code> and
<code>R</code> are of the same form as the key (<code>i,j,(s_h,h),loc_h</code>) and <code>p</code> is the
probability of this node rewriting to <code>L</code> and <code>R</code>,
eg. <code>inner(L)*inner(R)*p_GO_AT</code> or <code>p_STOP</code> or whatever. We only add this
entry to <code>mpptree</code> if there wasn't a higher-probability entry there
before.
</p>
<p>
Then, after <code>inner_sent</code> makes an <code>mpptree</code>, we find the <i>relevant</i>
head-argument pairs by searching through the tree using a queue,
adding the <code>L</code> and <code>R</code> keys of any entry to the queue as we find them
(skipping <code>STOP</code> keys), and adding any attachment entries to a set of
triples <code>(head,argument,dir)</code>. Thus we have our most probable parse,
eg.
<pre class="example">
 set([( ROOT, (vbd,2),RIGHT),
      ((vbd,2),(nn,1),LEFT),
      ((vbd,2),(nn,3),RIGHT),
      ((nn,1),(det,0),LEFT)])
</pre>
</p></div>
</div>

</div>

<div id="outline-container-7" class="outline-2">
<h2 id="sec-7">7 Initialization   </h2>
<div id="text-7">

<p><a href="/Users/kiwibird/Documents/Skole/V08/Probability/dmvccm/src/dmv.py">dmv-inits</a>
</p>
<p>
We go through the corpus, since the probabilities are based on how far
away in the sentence arguments are from their heads.
</p>
</div>

<div id="outline-container-7.1" class="outline-3">
<h3 id="sec-7.1">7.1 <span class="todo">TOGROK</span> CCM Initialization    </h3>
<div id="text-7.1">

<p>P<sub>SPLIT</sub> used here&hellip; how, again?
</p></div>
</div>

</div>

<div id="outline-container-8" class="outline-2">
<h2 id="sec-8">8 <span class="todo">TODO</span> [#C] Alternative CNF for DMV</h2>
<div id="text-8">


<p>
<a name="dmv2cnf">&nbsp;</a>
</p><ul>
<li>
<a href="src/cnf_dmv.py">cnf_dmv.py</a>
</li>
<li>
<a href="src/cnf_harmonic.py">cnf_harmonic.py</a>

</li>
</ul>

<p>See section 5 of <a href="tex/formulas.pdf">formulas.pdf</a>.
</p>
<p>
Given a grammar with certain p_ATTACH, p_STOP and p_ROOT, we get:
<pre class="example">
&gt;&gt;&gt; print testgrammar_h():
  h&gt;&lt; --&gt;   h&gt;  STOP   [0.30]
  h&gt;&lt; --&gt;  &gt;h&gt;  STOP   [0.40]
 _h_  --&gt; STOP    h&gt;&lt;  [1.00]
 _h_  --&gt; STOP   &lt;h&gt;&lt;  [1.00]
 &gt;h&gt;  --&gt;   h&gt;   _h_   [1.00]
 &gt;h&gt;  --&gt;  &gt;h&gt;   _h_   [1.00]
 &lt;h&gt;&lt; --&gt;  _h_    h&gt;&lt;  [0.70]
 &lt;h&gt;&lt; --&gt;  _h_   &lt;h&gt;&lt;  [0.60]
ROOT  --&gt; STOP   _h_   [1.00]
</pre>
</p>

</div>

<div id="outline-container-8.1" class="outline-3">
<h3 id="sec-8.1">8.1 <span class="todo">TODO</span> [#A] Make and implement an equivalent grammar that's <i>pure</i> CNF</h3>
<div id="text-8.1">

<p>&hellip;since I'm not sure about my unary reestimation rules (section 5 of
<a href="tex/formulas.pdf">formulas</a>).
</p>
<p>
For any rule where LHS is <code>_h_</code> we also have a corresponding one with
LHS <code>ROOT</code>, only difference being that we multiply in <code>p_ROOT(h)</code>.
</p>
<p>
For any rule where LHS is <code>.h&gt;</code>, we use adjacent probabilities for the
left child; if LHS is <code>&lt;h.</code> we use adjacent probabilities for the right
child. Only <code>_h_</code> and <code>_h&gt;_</code> (plus <code>ROOT</code>) get to introduce the pre-terminal
<code>h</code> (where <code>h</code>, <code>ROOT</code> and <code>_h_</code> all rewrite to the terminal
<code>'h'</code>), and only <code>_h_</code> and <code>_h&gt;_</code> (plus <code>ROOT</code>) act as STOP
rules (eg. get to multiply in <code>p(STOP)</code>).
</p>
<p>
<pre class="example">
  h   --&gt;  'h'         1
 _h_  --&gt;  'h'         p(STOP|h,L,adj) * p(STOP|h,R,adj)
 ROOT --&gt;  'h'         p(STOP|h,L,adj) * p(STOP|h,R,adj) * p_ROOT(h)

 _h_  --&gt;   h    _a_   p(STOP|h,L,adj) * p(STOP|h,R,non) * p(a|h,R)*p(-STOP|h,R,adj)
 _h_  --&gt;   h    .h&gt;   p(STOP|h,L,adj) * p(STOP|h,R,non) 
 .h&gt;  --&gt;  _a_   _b_   p(a|h,R)*p(-STOP|h,R,adj) * p(b|h,R)*p(-STOP|h,R,non)
 .h&gt;  --&gt;  _a_    h&gt;   p(a|h,R)*p(-STOP|h,R,adj) 
  h&gt;  --&gt;  _a_   _b_   p(a|h,R)*p(-STOP|h,R,non) * p(b|h,R)*p(-STOP|h,R,non)
  h&gt;  --&gt;  _a_    h&gt;   p(a|h,R)*p(-STOP|h,R,non) 

 _h_  --&gt;  _a_    h    p(STOP|h,L,non) * p(STOP|h,R,adj) * p(a|h,L)*p(-STOP|h,L,adj)
 _h_  --&gt;  &lt;h.    h    p(STOP|h,L,non) * p(STOP|h,R,adj) 
 &lt;h.  --&gt;  _b_   _a_   p(b|h,L)*p(-STOP|h,L,non) * p(a|h,L)*p(-STOP|h,L,adj)
 &lt;h.  --&gt;  &lt;h    _a_                               p(a|h,L)*p(-STOP|h,L,adj) 
 &lt;h   --&gt;  _a_   _b_   p(a|h,L)*p(-STOP|h,L,non) * p(b|h,L)*p(-STOP|h,L,non)
 &lt;h   --&gt;  &lt;h    _a_   p(a|h,L)*p(-STOP|h,L,non) 

 _h_  --&gt;  &lt;h.    _h&gt;_ p(STOP|h,L,non)
 _h_  --&gt;  _a_    _h&gt;_ p(STOP|h,L,non) * p(a|h,L)*p(-STOP|h,L,adj)
 _h&gt;_ --&gt;   h     .h&gt;  p(STOP|h,R,non) 
 _h&gt;_ --&gt;   h     _a_  p(STOP|h,R,non) * p(a|h,R)*p(-STOP|h,R,adj)

 ROOT --&gt;   h    _a_   p(STOP|h,L,adj) * p(STOP|h,R,non) * p(a|h,R)*p(-STOP|h,R,adj) * p_ROOT(h)
 ROOT --&gt;   h    .h&gt;   p(STOP|h,L,adj) * p(STOP|h,R,non) * p_ROOT(h)

 ROOT --&gt;  _a_    h    p(STOP|h,L,non) * p(STOP|h,R,adj) * p(a|h,L)*p(-STOP|h,L,adj) * p_ROOT(h)
 ROOT --&gt;  &lt;h.    h    p(STOP|h,L,non) * p(STOP|h,R,adj) * p_ROOT(h)

 ROOT --&gt;  &lt;h.   _h&gt;_  p(STOP|h,L,non) * p_ROOT(h)
 ROOT --&gt;  _a_   _h&gt;_  p(STOP|h,L,non) * p(a|h,L)*p(-STOP|h,L,adj) * p_ROOT(h)

</pre>
</p>
<p>
Since we have rules rewriting <code>h</code> to <code>a</code> and <code>b</code>, we have a rule-set
numbering more than n<sub>tags</sub><sup>2</sup>.
</p>
</div>

</div>

<div id="outline-container-8.2" class="outline-3">
<h3 id="sec-8.2">8.2 <span class="todo">TOGROK</span> [#A] convert L&amp;Y-based reestimation into P_ATTACH and P_STOP values</h3>
<div id="text-8.2">

<p>Sum over the various rules? Or something? Must think of this.
</p></div>

</div>

<div id="outline-container-8.3" class="outline-3">
<h3 id="sec-8.3">8.3 <span class="todo">TODO</span> [#C] move as much as possible into common_dmv.py</h3>
<div id="text-8.3">

<p><a href="src/common_dmv.py">common_dmv.py</a>
</p></div>

</div>

<div id="outline-container-8.4" class="outline-3">
<h3 id="sec-8.4">8.4 <span class="done">DONE</span> L&amp;Y-based reestimation for cnf_dmv</h3>
<div id="text-8.4">

<p><span class="timestamp-kwd">CLOSED: </span> <span class="timestamp">2008-08-21 Thu 16:35</span><br/>
</p></div>

</div>

<div id="outline-container-8.5" class="outline-3">
<h3 id="sec-8.5">8.5 <span class="done">DONE</span> dmv2cnf re-estimation formulas</h3>
<div id="text-8.5">

<p><span class="timestamp-kwd">CLOSED: </span> <span class="timestamp">2008-08-21 Thu 16:36</span><br/>
</p></div>

</div>

<div id="outline-container-8.6" class="outline-3">
<h3 id="sec-8.6">8.6 <span class="done">DONE</span> inner and outer for cnf_dmv.py, also cnf_harmonic.py </h3>
<div id="text-8.6">

</div>
</div>

</div>

<div id="outline-container-9" class="outline-2">
<h2 id="sec-9">9 [#C] Deferred</h2>
<div id="text-9">

<p><a href="http://wiki.python.org/moin/PythonSpeed/PerformanceTips">http://wiki.python.org/moin/PythonSpeed/PerformanceTips</a> Eg., use
map/reduce/filter/[i for i in [i's]]/(i for i in [i's]) instead of
for-loops; use local variables for globals (global variables or or
functions), etc.
</p>
</div>

<div id="outline-container-9.1" class="outline-3">
<h3 id="sec-9.1">9.1 <span class="todo">TODO</span> Clean up reestimation code                                    &nbsp;&nbsp;&nbsp;<span class="tag">PRETTIER</span></h3>
<div id="text-9.1">

</div>

</div>

<div id="outline-container-9.2" class="outline-3">
<h3 id="sec-9.2">9.2 <span class="todo">TODO</span> [#A] compare speed of w_left/right(&hellip;) and w(LEFT/RIGHT, &hellip;) &nbsp;&nbsp;&nbsp;<span class="tag">OPTIMIZE</span></h3>
<div id="text-9.2">

</div>

</div>

<div id="outline-container-9.3" class="outline-3">
<h3 id="sec-9.3">9.3 <span class="todo">TODO</span> when reestimating P_STOP etc, remove rules with p &lt; epsilon   &nbsp;&nbsp;&nbsp;<span class="tag">OPTIMIZE</span></h3>
<div id="text-9.3">

</div>

</div>

<div id="outline-container-9.4" class="outline-3">
<h3 id="sec-9.4">9.4 <span class="todo">TODO</span> inner_dmv, short ranges and impossible attachment             &nbsp;&nbsp;&nbsp;<span class="tag">OPTIMIZE</span></h3>
<div id="text-9.4">

<p>If s-t &lt;= 2, there can be only one attachment below, so don't recurse
with both Lattach=True and Rattach=True.
</p>
<p>
If s-t &lt;= 1, there can be no attachment below, so only recurse with
Lattach=False, Rattach=False.
</p>
<p>
Put this in the loop under rewrite rules (could also do it in the STOP
section, but that would only have an effect on very short sentences).
</p></div>

</div>

<div id="outline-container-9.5" class="outline-3">
<h3 id="sec-9.5">9.5 <span class="todo">TODO</span> clean up the module files                                     &nbsp;&nbsp;&nbsp;<span class="tag">PRETTIER</span></h3>
<div id="text-9.5">

<p>Is there better way to divide dmv and harmonic? There's a two-way
dependency between the modules. Guess there could be a third file that
imports both the initialization and the actual EM stuff, while a file
containing constants and classes could be imported by all others:
<pre class="example">
 dmv.py imports dmv_EM.py imports dmv_classes.py
 dmv.py imports dmv_inits.py imports dmv_classes.py
</pre>
</p>
</div>

</div>

<div id="outline-container-9.6" class="outline-3">
<h3 id="sec-9.6">9.6 <span class="todo">TOGROK</span> Some (tagged) sentences are bound to come twice             &nbsp;&nbsp;&nbsp;<span class="tag">OPTIMIZE</span></h3>
<div id="text-9.6">

<p>Eg, first sort and count, so that the corpus
[['nn','vbd','det','nn'],
['vbd','nn','det','nn'],
['nn','vbd','det','nn']]
becomes
[(['nn','vbd','det','nn'],2),
(['vbd','nn','det','nn'],1)]
and then in each loop through sentences, make sure we handle the
frequency correctly.
</p>
<p>
Is there much to gain here?
</p>
</div>

</div>

<div id="outline-container-9.7" class="outline-3">
<h3 id="sec-9.7">9.7 <span class="todo">TOGROK</span> tags as numbers or tags as strings?                         &nbsp;&nbsp;&nbsp;<span class="tag">OPTIMIZE</span></h3>
<div id="text-9.7">

<p>Need to clean up the representation.
</p>
<p>
Stick with tag-strings in initialization then switch to numbers for
IO-algorithm perhaps? Can probably afford more string-matching in
initialization..
</p></div>
</div>

</div>

<div id="outline-container-10" class="outline-2">
<h2 id="sec-10">10 Adjacency and combining it with the inside-outside algorithm</h2>
<div id="text-10">

<p>Each DMV probability (for a certain PCFG node) has both an adjacent
and a non-adjacent probability. inner() and outer() needs the correct
one in each case.
</p>
<p>
In each inner() call, loc_h is the location of the head of this
dependency structure. In each outer() call, it's the head of the <i>Node</i>,
the structure we're looking outside of.
</p>
<p>
We call inner() for each location of a head, and on each terminal,
loc_h must equal <code>i</code> (and <code>loc_h+1</code> equal <code>j</code>). In the recursive attachment
calls, we use the locations (sentence indices) of words to the left or
right of the head in calls to inner(). <i>loc_h lets us check whether we need probN or probA</i>.
</p>
</div>

<div id="outline-container-10.1" class="outline-3">
<h3 id="sec-10.1">10.1 Possible alternate type of adjacency</h3>
<div id="text-10.1">

<p>K&amp;M's adjacency is just whether or not an argument has been generated
in the current direction yet. One could also make a stronger type of
adjacency, where h and a are not adjacent if b is in between, eg. with
the sentence "a b h" and the structure ((h-&gt;a), (a-&gt;b)), h is
K&amp;M-adjacent to a, but not next to a, since b is in between. It's easy
to check this type of adjacency in inner(), but it needs new rules for
P_STOP reestimation.
</p></div>
</div>

</div>

<div id="outline-container-11" class="outline-2">
<h2 id="sec-11">11 Python-stuff</h2>
<div id="text-11">

<p>Make those debug statements steal a bit less attention in emacs:
<pre class="example">
(font-lock-add-keywords
 'python-mode                   ; not really regexp, a bit slow
 '(("^\\( *\\)\\(\\if +'.+' +in +io.DEBUG. *\\(
\\1    .+$\\)+\\)" 2 font-lock-preprocessor-face t)))
(font-lock-add-keywords
 'python-mode
 '(("\\&lt;\\(\\(io\\.\\)?debug(.+)\\)" 1 font-lock-preprocessor-face t)))
</pre>
</p>
<ul>
<li>
<a href="src/pseudo.py">pseudo.py</a>
</li>
<li>
<a href="http://nltk.org/doc/en/structured-programming.html">http://nltk.org/doc/en/structured-programming.html</a> recursive dynamic
</li>
<li>
<a href="http://nltk.org/doc/en/advanced-parsing.html">http://nltk.org/doc/en/advanced-parsing.html</a> 
</li>
<li>
<a href="http://jaynes.colorado.edu/PythonIdioms.html">http://jaynes.colorado.edu/PythonIdioms.html</a>



</li>
</ul>
</div>

</div>

<div id="outline-container-12" class="outline-2">
<h2 id="sec-12">12 Git</h2>
<div id="text-12">

<p>Repository web page: <a href="http://repo.or.cz/w/dmvccm.git">http://repo.or.cz/w/dmvccm.git</a>
</p>
<p>
Setting up a new project:
<pre class="example">
 git init
 git add .
 git commit -m "first release"
</pre>
</p>
<p>
Later on: (<code>-a</code> does <code>git rm</code> and <code>git add</code> automatically)
<pre class="example">
 git init
 git commit -a -m "some subsequent release"
</pre>
</p>
<p>
Then push stuff up to the remote server:
<pre class="example">
 git push git+ssh://username@repo.or.cz/srv/git/dmvccm.git master
</pre>
</p>
<p>
(<code>eval `ssh-agent`</code> and <code>ssh-add</code> to avoid having to type in keyphrase all
the time)
</p>
<p>
Make a copy of the (remote) master branch:
<pre class="example">
 git clone git://repo.or.cz/dmvccm.git 
</pre>
</p>
<p>
Make and name a new branch in this folder
<pre class="example">
 git checkout -b mybranch
</pre>
</p>
<p>
To save changes in <code>mybranch</code>:
<pre class="example">
 git commit -a 
</pre>
</p>
<p>
Go back to the master branch (uncommitted changes from <code>mybranch</code> are
carried over):
<pre class="example">
 git checkout master
</pre>
</p>
<p>
Try out:
<pre class="example">
 git add --interactive
</pre>
</p>
<p>
Good tutorial:
<a href="http://www-cs-students.stanford.edu/~blynn//gitmagic/">http://www-cs-students.stanford.edu/~blynn//gitmagic/</a> 
</p></div>
</div>
<div id="postamble"><p class="author"> Author: Kevin Brubeck Unhammer
<a href="mailto:K.BrubeckUnhammer at student uva nl ">&lt;K.BrubeckUnhammer at student uva nl &gt;</a>
</p>
<p class="date"> Date: 2008-09-21 19:00:58 CEST</p>
<p>HTML generert av <a href='http://orgmode.org/'>org-mode</a> 6.06b in emacs 22<p>
</div><script src="./post-script.js" type="text/JavaScript">
</script></body>
</html>
